/*
 * Timer.h
 *
 *  Created on: 07/giu/2012
 *      Author: bertini
 */

#ifndef TIMER_H_
#define TIMER_H_

#include <list>
#include "Subject.h"
#include "Observer.h"

class Timer : public Subject {
public:
	Timer();
	virtual ~Timer();

	virtual void subscribe(Observer* in);
	virtual void unsubscribe(Observer* out);
	virtual void notify();

	void tick();

	int getSecond() const {
		return seconds;
	}
	void setSeconds(int value) {
		seconds = value;
		notify();
	}

private:
	int seconds;

	std::list<Observer*> observers;
};

#endif /* TIMER_H_ */
